var tabloc_pref = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefBranch);

function tabloc_init() {
	if(!gBrowser){ return; }

	tabloc_addKey("lock_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_lock"),
		tabloc_pref.getCharPref("extensions.tabloc.key_lock"));
	tabloc_addKey("protect_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_protect"),
		tabloc_pref.getCharPref("extensions.tabloc.key_protect"));
	tabloc_addKey("lock_protect_tab_menu",
		tabloc_pref.getCharPref("extensions.tabloc.keymodifiers_lock_protect"),
		tabloc_pref.getCharPref("extensions.tabloc.key_lock_protect"));

	if(tabloc_pref.getBoolPref("extensions.tabloc.add.lock_tab_menu")){
		tabloc_addMenuItem(gBrowser, "lock_tab_menu", 0)
	}
	if(tabloc_pref.getBoolPref("extensions.tabloc.add.protect_tab_menu")){
		tabloc_addMenuItem(gBrowser, "protect_tab_menu", 1);
	}
	if(tabloc_pref.getBoolPref("extensions.tabloc.add.lock_protect_tab_menu")){
		tabloc_addMenuItem(gBrowser, "lock_protect_tab_menu", 2);
	}

	gBrowser.tabContainer.addEventListener("dblclick", tabloc_dblclick, false);

	gBrowser.tabContainer.addEventListener("mousedown", tabloc_mousedown, false);
	gBrowser.tabContainer.addEventListener("mouseup",   tabloc_mouseup, false);

	var menuParent = gBrowser.mStrip.firstChild.nextSibling;
	if(menuParent){
		menuParent.addEventListener("popupshowing", tabloc_updateChecked, false);
	}

	tabloc_override_removeTab();
}

function tabloc_lockTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_locked") ) {
		aTab.removeAttribute("__tabloc_locked");
		tabloc_restore_loadURI(gBrowser.getBrowserForTab(aTab));
	} else {
		aTab.setAttribute("__tabloc_locked", "true");
		tabloc_override_loadURI(gBrowser.getBrowserForTab(aTab));
	}
}

function tabloc_protectTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_protected")) {
		aTab.removeAttribute("__tabloc_protected");
	} else {
		aTab.setAttribute("__tabloc_protected", "true");
	}
}

function tabloc_lockProtectTab(aTab) {
	if (aTab.localName != "tab") { aTab = gBrowser.selectedTab; }
	if (tabloc_isIgnoredTab(aTab)) { return; }

	if (aTab.hasAttribute("__tabloc_locked") && aTab.hasAttribute("__tabloc_protected")) {
		aTab.removeAttribute("__tabloc_locked");
		aTab.removeAttribute("__tabloc_protected");
		tabloc_restore_loadURI(gBrowser.getBrowserForTab(aTab));
	} else {
		aTab.setAttribute("__tabloc_locked", "true");
		aTab.setAttribute("__tabloc_protected", "true");
		tabloc_override_loadURI(gBrowser.getBrowserForTab(aTab));
	}
}

function tabloc_override_removeTab(){
	var strRemoveTab = gBrowser.removeTab.toString();
	var pos = strRemoveTab.indexOf('{');
	eval("gBrowser.removeTab = " + strRemoveTab.substr(0, pos+1)
	  + "\nif(!tabloc_canRemoveTab(aTab)) { return; }\n"
	  + strRemoveTab.substr(pos+1));
}

function tabloc_override_loadURI(browser){
	browser.addEventListener("click", tabloc_check_click, true);

	browser.__tabloc_loadURI = browser.loadURI;
	var strLoadURI = browser.loadURI.toString();
	var pos = strLoadURI.indexOf('{');
	eval("browser.loadURI = " + strLoadURI.substr(0, pos+1)
	  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
	  + "  var fgtab = tabloc_pref.getBoolPref(\"extensions.tabloc.open_foreground\");\n"
	  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, null, !fgtab);\n"
	  + "  return;\n"
	  + "}\n"
	  + strLoadURI.substr(pos+1));

	browser.__tabloc_loadURIWithFlags = browser.loadURIWithFlags;
	var strLoadURIWithFlags = browser.loadURIWithFlags.toString();
	var pos = strLoadURIWithFlags.indexOf('{');
	eval("browser.loadURIWithFlags = " + strLoadURIWithFlags.substr(0, pos+1)
	  + "\nif(gBrowser.selectedTab.hasAttribute(\"__tabloc_locked\")) {\n"
	  + "  var fgtab = tabloc_pref.getBoolPref(\"extensions.tabloc.open_foreground\");\n"
	  + "  gBrowser.loadOneTab(aURI, aReferrerURI, aCharset, aPostData, !fgtab);\n"
	  + "  return;\n"
	  + "}\n"
	  + strLoadURIWithFlags.substr(pos+1));
}

function tabloc_restore_loadURI(browser){
	try{
		if(browser.__tabloc_loadURI){
			browser.loadURI = browser.__tabloc_loadURI;
			browser.__tabloc_loadURI = null;
		}
		if(browser.__tabloc_loadURIWithFlags){
			browser.loadURIWithFlags = browser.__tabloc_loadURIWithFlags;
			browser.__tabloc_loadURIWithFlags = null;
		}
		browser.removeEventListener("click", tabloc_check_click, true);
		
		var elements = document.getElementsByAttribute("__tabloc_override_target", "true");
		for(var i=0; i<elements.length; i++){
			var element = elements[i];
			element.target = element.getAttribute("__tabloc_target");
			element.removeAttribute("__tabloc_override_target");
			element.removeAttribute("__tabloc_target");
		}
	}catch(e){}
}

function tabloc_isIgnoredTab(aTab){
	try{
		if (tabloc_pref.getBoolPref("extensions.tabloc.ex_aboutblank")) {
			var url = gBrowser.getBrowserForTab(aTab).currentURI.spec;
			if(url == "" || url == "about:blank"){
				return true;
			}
		}
	}catch(e){ }
	return false;
}

function tabloc_canRemoveTab(aTab){
	try{
		if(gBrowser.selectedTab == aTab && 
			tabloc_pref.getBoolPref("extensions.tabloc.close_active")){
			return true;
		}
		if(aTab.hasAttribute("__tabloc_protected")){
			return false;
		}
	}catch(e){ }
	return true;
}

function tabloc_check_click(evt){
	if(evt && evt.target){
		var a = evt.target;
		var exinpage     = tabloc_pref.getBoolPref("extensions.tabloc.ex_inpagelink");
		var exjavascript = tabloc_pref.getBoolPref("extensions.tabloc.ex_javascript");
		var exform       = tabloc_pref.getBoolPref("extensions.tabloc.ex_formsubmit");

		if(exinpage && a.href){
			var nowhref = a.ownerDocument.URL.split("#")[0];
			if(a.href === nowhref || a.href.indexOf(nowhref + "#") == 0){
				return;
			}
		}
		if(exjavascript && a.href){
			if(a.href.indexOf("javascript:") == 0){
				return;
			}
		}
		if(a.tagName.toLowerCase() === "input"){
			if(!exform){ tabloc_form(a); }
		}else{
			var fgtab = tabloc_pref.getBoolPref("extensions.tabloc.open_foreground");
			var sendref = tabloc_pref.getBoolPref("extensions.tabloc.send_referer");
			tabloc_href(evt, fgtab, sendref);
		}
	}
}

function tabloc_form(a){
	while(a && a.tagName.toLowerCase() != "form"){
		a = a.parentNode;
	}
	if(a){
		a.setAttribute("__tabloc_override_target", "true");
		a.setAttribute("__tabloc_target", a.target);
		a.target = "_blank";
	}
}

function tabloc_href(evt, fgtab, sendref){
	var a = evt.target;
	while(a && !a.href){
	  a = a.parentNode;
	}
	if(!a.href){ return; }
	if(!gBrowser){ return; }

	if(sendref){
		var browser = gBrowser.getBrowserForDocument(a.ownerDocument);
		if(!browser){ browser = gBrowser.selectedBrowser; }
		var referer = browser.currentURI;
		gBrowser.loadOneTab(a.href, referer, null, null, !fgtab);
	}else{
		gBrowser.loadOneTab(a.href, null, null, null, !fgtab);
	}
	evt.preventDefault();
}

function tabloc_addKey(menuid, modifiers, keycode) {
	var key = document.getElementById("key_" + menuid);
  if(keycode.length == 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("key", keycode);
    key.setAttribute("disabled", false);
  }else if(keycode.length > 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("keycode", "VK_" + keycode);
    key.setAttribute("disabled", false);
  }
}

function tabloc_addMenuItem(contentBrowser, menuid, menuindex) {
	var newMenu = document.getElementById(menuid).cloneNode(false);
	if(!newMenu){ return null; }
	newMenu.id = "tab-" + menuid;
	var menuParent = contentBrowser.mStrip.firstChild.nextSibling;
	var pos = tabloc_pref.getIntPref("extensions.tabloc.menu_pos") + menuindex;
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(newMenu);
	}else{
	  menuParent.insertBefore(newMenu, menuParent.childNodes[pos]);
	}
	return newMenu;
}

function tabloc_dblclick(){
	switch(tabloc_pref.getIntPref("extensions.tabloc.dblclick_action")){
		case 1: tabloc_lockTab(false); break;
		case 2: tabloc_protectTab(false); break;
		case 3: tabloc_lockProtectTab(false); break;
		default: break;
	}
}

var tabloc_mousedown_browser = null;
function tabloc_mousedown(){
	if(!gBrowser){ return; }
	var ctab = gBrowser.selectedTab;
	tabloc_mousedown_browser = gBrowser.selectedBrowser;
	var time = tabloc_pref.getIntPref("extensions.tabloc.longpush_time");
	tabloc_mousedown_browser.__tabloc_timer = tabloc_mousedown_browser.contentWindow.setTimeout(tabloc_longpush, time, ctab);
}

function tabloc_mouseup(){
	if(tabloc_mousedown_browser != null){
		tabloc_mousedown_browser.contentWindow.clearTimeout(tabloc_mousedown_browser.__tabloc_timer);
	}
}

function tabloc_longpush(){
	switch(tabloc_pref.getIntPref("extensions.tabloc.longpush_action")){
		case 1: tabloc_lockTab(false); break;
		case 2: tabloc_protectTab(false); break;
		case 3: tabloc_lockProtectTab(false); break;
		default: break;
	}
}

function tabloc_setChecked(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	if(value){
		item.setAttribute("checked", true);
	}else{
		item.removeAttribute("checked");
	}
}

function tabloc_setVisible(id, value) {
	var item = gBrowser.ownerDocument.getElementById(id);
	if(item == null){ return; }
	var style = item.getAttribute("style");
	if(value){
		item.setAttribute("style", style.replace("display: none;",""));
	}else{
		item.setAttribute("style", "display: none;" + style);
	}
}

function tabloc_updateChecked() {
	var aTab = gBrowser.mContextTab;
	if(!aTab){ return; }
	if(tabloc_isIgnoredTab(aTab)){
		tabloc_setVisible("tab-lock_tab_menu", false);
		tabloc_setVisible("tab-protect_tab_menu", false);
		tabloc_setVisible("tab-lock_protect_tab_menu", false);
		return;
	}
	var l = aTab.hasAttribute("__tabloc_locked");
	var p = aTab.hasAttribute("__tabloc_protected");
	tabloc_setChecked("tab-lock_tab_menu", l);
	tabloc_setChecked("tab-protect_tab_menu", p);
	tabloc_setChecked("tab-lock_protect_tab_menu", l && p);
	tabloc_setVisible("tab-lock_tab_menu", true);
	tabloc_setVisible("tab-protect_tab_menu", true);
	tabloc_setVisible("tab-lock_protect_tab_menu", true);
}

